using IceCreamShopContracts.BindingModels;
using IceCreamShopContracts.ViewModels;
using AbstractIceCreamShopDataModels.Models;
using System.Runtime.Serialization;

namespace IceCreamShopListImplement.Models
{
	[DataContract]
	public class Client : IClientModel
    {
        [DataMember]
		public string ClientFIO { get; private set; } = string.Empty;

        [DataMember]
		public string Email { get; private set; } = string.Empty;

        [DataMember]
		public string Password { get; private set; } = string.Empty;

        [DataMember]
		public int Id { get; private set; }

        public static Client? Create(ClientBindingModel model)
        {
            if (model == null)
            {
                return null;
            }
            return new()
            {
                Id = model.Id,
                ClientFIO = model.ClientFIO,
                Email = model.Email,
                Password = model.Password
            };
        }

        public void Update(ClientBindingModel model)
        {
            if (model == null)
            {
                return;
            }
            ClientFIO = model.ClientFIO;
            Email = model.Email;
            Password = model.Password;
        }

        public ClientViewModel GetViewModel => new()
        {
            Id = Id,
            ClientFIO = ClientFIO,
            Email = Email,
            Password = Password,
        };
    }
}
